<?php

namespace App\Http\Controllers;
use App\User;
use App\aplicacion;
use App\usuarios_app;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\Hash;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Crypt;


class usersController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index($role = null)
    {
        $users = User::orderBy('id', 'desc')->paginate(10);
        if($role != null) {
            $users = DB::table('users')
            ->where('role',$role)->orderBy('id', 'desc')->paginate(10);
        }
        return view('admin.users.users',[
            'users'=>$users
        ]);
    }
    public function userByRole($id)
    {
        $users =DB::table('users')
            ->where('role',$id)
            ->get();
            return json_encode($users);
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        //
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        //
    }
    
    public function login()
    {
        $rules = array(
            'email'    => 'required|email', 
            'password' => 'required|alphaNum|min:2' 
        );

        $validator = Validator::make(Input::all(), $rules);

    }
    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function user($id)
    {
        $users = User::find($id);
        if(!$users) {
            return redirect('error');
        }
        $requerimientos_desarrollador = DB::table('requerimientos_desarrolladores')
            ->join('requerimientos','requerimientos.id','requerimientos_desarrolladores.requerimiento_id')
            ->where('desarrollador_id',$id)
            ->select('requerimientos_desarrolladores.*','requerimientos.titulo as requerimiento_titulo','requerimientos.descripcion as requerimiento_descripcion')
            ->get();
        $aplicacion_name = DB::table('usuarios_app')
            ->join('aplicacion','aplicacion.id', 'usuarios_app.app_id')
            ->select('usuarios_app.*', 'aplicacion.nombre as app_name')->where('user_id',$id)
            ->get();
        return view('admin.users.user',[
            'users'=>$users,
            'aplicacion_name' => $aplicacion_name,
            'requerimientos_desarrollador' => $requerimientos_desarrollador
         ]);
    }
    public function asignarApp($id)
    {
        $usuario = User::find($id);;
        $aplicaciones = aplicacion::all();
        return view('admin.users.asignarApp', [
            'usuario'=>$usuario,
            'aplicaciones'=> $aplicaciones
        ]);
    }

    public function guardarAppAsignada($id, Request $request)
    {
        if( empty($request['nombre']) == null || Auth::user()->role=='admin') {
            usuarios_app::create([
                'user_id' => $request['usuario'],
                'app_id' => $request['aplicacion']
            ]);
            return redirect('user/'.$id);
            
        }
        
    }
    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        //
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $request->validate([
            'name' => 'required|max:20',
            'email' => 'required|email',
            'surname' => 'required',
            'idCard' => 'required',
            'address' => 'required',
            'tel' => 'required',
            'role' => 'required',
        ]);
        if(Auth::user()->role=='admin'){
            $user = user::find($id);
            $user->name =$request->name;
            $user->email =$request->email;
            $user->surname =$request->surname;
            $user->idCard =$request->idCard;
            $user->address =$request->address;
            $user->tel =$request->tel;
            $user->role =$request->role;
            $user->estado =$request->estado;
            $user->update();
            if($request->file('img')) {
                $path = $request->file('img')->storeAs(
                    'public/users', $id 
                );
            }
        }
        return redirect('user/'.$id);
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        User::destroy($id);
    }

    public function destroyAppUser($id)
    {
        usuarios_app::destroy($id);
    }
}
